<?php

declare(strict_types=1);

namespace Pinpoint\AdditionalCountries\Plugin\Framework\Locale;

use Magento\Framework\Locale\ListsInterface;

/**
 * This class intercepts methods of the class \Magento\Framework\Locale\TranslatedLists
 * @see \Magento\Framework\Locale\TranslatedLists
 */
class TranslatedLists
{
    /**
     * @var array|string[]
     */
    private array $translations;

    /**
     * @param array|string[] $translations
     */
    public function __construct(array $translations)
    {
        $this->translations = $translations;
    }

    /**
     * Add additional countries to the list of translations
     *
     * @param \Magento\Framework\Locale\ListsInterface $subject
     * @param callable                                 $proceed
     * @param string                                   $value
     * @param string|null                              $locale
     *
     * @return string
     *
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     */
    public function aroundGetCountryTranslation(
        ListsInterface $subject,
        callable       $proceed,
        string         $value,
        string         $locale = null
    ): string {
        return $this->translations[$value] ?? (string) $proceed($value, $locale);
    }
}
